<script lang="ts">
import Vue from 'vue';
import AnimatedNumber from './animated-number.vue';
import SurveyGraphBar from './survey-graph-bar.vue';

export default Vue.extend({
  name: 'SurveyStatBarsSection',
  components: {
    AnimatedNumber,
    SurveyGraphBar,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <section class="survey-stat-bars">
    <SlpContainer>
      <div
        :data-aos="data.aos_animation"
        :data-aos-duration="data.aos_duration"
        :data-aos-offset="data.aos_offset"
      >
        <SlpTypography
          v-if="data.title"
          variant="heading4-bold"
          tag="div"
          class="survey-stat-bars__title slp-mb-16"
          >{{ data.title }}</SlpTypography
        >
        <SlpTypography
          v-if="data.description"
          variant="heading5-bold"
          tag="div"
          class="slp-mb-32"
          >{{ data.description }}</SlpTypography
        >
      </div>
      <SlpRow class="survey-stat-bars__row">
        <SlpColumn
          v-for="block in data.blocks"
          :key="block.title ?? block.description"
          :cols="block.size ?? 6"
          size="lg"
          class="survey-stat-bars__col"
          :data-aos="block.aos_animation"
          :data-aos-duration="block.aos_duration"
          :data-aos-offset="block.aos_offset"
        >
          <SlpTypography v-if="block.title" variant="heading4-bold" tag="div">{{
            block.title
          }}</SlpTypography>
          <SlpTypography v-if="block.description" variant="body2" tag="div">{{
            block.description
          }}</SlpTypography>
          <div
            v-for="bar in block.stats"
            :key="bar.legend"
            class="survey-stat-bars__stat"
          >
            <div class="survey-stat-bars__wrapper">
              <SurveyGraphBar
                :color="bar.color"
                :percentage="bar.percentage"
                :scale="block.scale"
              />
              <SlpTypography
                v-if="bar.legend"
                variant="body2"
                tag="div"
                class="survey-stat-bars__legend"
                >{{ bar.legend }}</SlpTypography
              >
            </div>
            <div class="survey-stat-bars__percentage">
              <SlpTypography
                v-if="bar.percentage"
                variant="heading4-bold"
                tag="div"
                ><AnimatedNumber :number="bar.percentage"
              /></SlpTypography>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.survey-stat-bars {
  color: $color-primary-300;

  &__col {
    width: 100%;
    margin-bottom: $spacing-48;
  }
  &__wrapper {
    margin-right: $spacing-16;
    flex: 1;
  }
  &__stat {
    display: flex;
    margin: $spacing-24 0 0 0;
    @media (min-width: $breakpoint-md) {
      margin: $spacing-24 $spacing-24 0 0;
    }
  }
  &__title {
    color: #5dd7b1;
  }
  &__legend {
    margin-top: $spacing-8;
    font-family: 'GitLab Mono', sans-serif;
  }
  &__percentage {
    width: 55px;
    font-family: 'GitLab Mono', sans-serif;
  }
}
</style>
